//+------------------------------------------------------------------+
//|                                                       II_LIS.mq4 |
//|                            Copyright  2011, Insanity Industries |
//|                                http://www.insanityindustries.net |
//| Shows lines in the sand for all timeframes.
//| v1.0 08/6/11
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Insanity Industries"
#property link      "http://www.insanityindustries.net"
#property indicator_chart_window

extern int object.layer = 5;
extern bool HELP = false;
extern bool kill.lines.on.close = false;
extern bool show.all.lines = false;
extern bool background.lines = true;
extern bool show.hud = true;
extern bool show.Box = true;
extern int hud.corner = 1;
extern int pos.x = 20;
extern int pos.y = 20;
extern color color.border = Yellow;
extern color color.box = Black;
extern bool alert.close.over = false;
extern bool alert.price.touch = false;
extern int style.m1 = 0;
extern int width.m1 = 1;
extern color color.m1 = Red;
extern int style.m5 = 0;
extern int width.m5 = 1;
extern color color.m5 = Red;
extern int style.m15 = 0;
extern int width.m15 = 1;
extern color color.m15 = Red;
extern int style.m30 = 0;
extern int width.m30 = 1;
extern color color.m30 = Red;
extern int style.h1 = 0;
extern int width.h1 = 1;
extern color color.h1 = Red;
extern int style.h4 = 0;
extern int width.h4 = 1;
extern color color.h4 = Red;
extern int style.d1 = 0;
extern int width.d1 = 1;
extern color color.d1 = Red;
extern int style.w1 = 0;
extern int width.w1 = 1;
extern color color.w1 = Red;
extern int style.mn = 0;
extern int width.mn = 1;
extern color color.mn = Red;

string f.arrow = "WingDings";
string arrow.up, arrow.dn, arrow.eq;
color color.up = LimeGreen;
color color.dn = Red;
color color.eq = Gold;

string TAG,s,n,pair;
int i,j;
double point,p,v;
bool draw;
datetime barstart[54];
bool touch.alert.toggle[9];
bool touch.alert,cross.alert;
double last.bid[9];

int showtf[] = {1,2,4,8,16,32,64,128,256};
int tf[] = {PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};
string tf.name[] = {"1 Minute","5 Minute","15 Minute","30 Minute","Hourly","4-Hourly","Daily","Weekly","Monthly"};
int lcu,lcd,wcu,wcd;
bool close.alert=false;
color c[9];
int wd[9],st[9];

int box.xoffset[] = {1,41,83,125,167,209,251};
int offset.x,offset.y;
string l.hud,l.c;
int x.hud,y.hud;

int hud.col.r[] = {180,130,110,90,70,53,5};
int hud.col.l[] = {5,73,120,140,160,180,198};
int hud.row.u[] = {95,115,133,151,169,187,205,223,241,259};
int hud.row.d[] = {45,27,9};
int hud.offset.l[] = {106,0,0,15,15,15,15,30,0,0,0,0,0,0,0,0,0,0};
int hud.offset.r[] = {10,0,5,-5,-5,-5,-8,5,0,0,0,0,0,0,0,0,0,0};
int hud.offset.hy.r[] = {0,0,13,13,15,15,13};
int hud.offset.hy.l[] = {0,0,-68,-53,-53,-25,-35};
int hud.t[] = {0,1,2,3,4,5,6,7,8,15,22,29,36,43,50,57,64,71};
int hud.d[] = {9,10,11,12,13,14,16,17,18,19,20,21,23,24,25,26,27,28,30,31,32,33,34,35,37,38,39,40,41,42,44,45,46,47,48,49,51,52,53,54,55,56,58,59,60,61,62,63,65,66,67,68,69,70};
int hud.fhs[] = {16,14,12,12,12,12,12,12,12,12,12,12,12,12,12,12,12,65};
int hud.ha[] =  {0, 0,0,-90,-90,-90,-90,-90,0, 0, 0, 0, 0, 0, 0, 0, 0};
int hud.x[73],hud.y[73],hud.xs[73],hud.ys[73],hud.dfs[73];
color hud.t.c[] = {DarkSeaGreen,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,DarkGoldenrod,Navy};
color hud.t.cs[] = {DarkGreen,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,Sienna,DarkSlateGray};
color hud.dc[54];
string hud.data[54],hud.fhn[18],hud.dfn[54];
string hud.header[] = {"Lines In The Sand","","Price","Current Price","Last Close","Last Cross","Wicks","Distance","1 Minute","5 Minute","15 Minute","30 Minute","Hourly","4 Hourly","Daily","Weekly","Monthly","$"};
bool dh[6];

int init(){
   arrow.up = CharToStr(241);
   arrow.dn = CharToStr(242);
   arrow.eq = CharToStr(243);
   l.hud = CharToStr(0x61+object.layer);
   l.c = CharToStr(0x61+object.layer-1);
   pair = Symbol();
   ArrayInitialize(barstart,0);
   for (i=0;i<ArraySize(hud.fhn);i++) hud.fhn[i] = "Pieces of Eight";
   for (i=0;i<6;i++) for (j=0;j<9;j++) {
      if(i==1 || i==2 || i==3) hud.dfn[(j*6)+i] = f.arrow;
         else hud.dfn[(j*6)+i] = "Pieces of Eight";
   }
   ArrayInitialize(hud.dfs,11);
   ArrayInitialize(dh,true);
   ArrayInitialize(hud.dc,Gold);
   ArrayInitialize(barstart,0);
   point = Point;
   if(Digits==3 || Digits==5) point*=10;
   TAG = CharToStr(0x61+object.layer)+"II_LIS";
   setLine();
   DoLogo();
   if(show.hud) setHUD();
   if(HELP) help();
   drawData();
   ArrayInitialize(dh,false);
   ArrayInitialize(last.bid,Bid);
   return(0);
}

int deinit(){
   Comment("");
   if(kill.lines.on.close) ObDeleteObjectsByPrefix(TAG);
   ObDeleteObjectsByPrefix(l.c+TAG);
   ObDeleteObjectsByPrefix(l.hud+TAG);
   return(0);
}

int start(){
   currentPrice();
   lastClose();
   lastCross();
   distance();
   lineValue();
   drawData();
   if(alert.price.touch) touchAlert();
   if(alert.close.over) crossAlert();
   return(0);
}

void touchAlert(){
   touch.alert = false;
   for(i=0;i<9;i++){
      if(barstart[(i*6)+1] == iTime(pair,tf[i],0)) continue;
      barstart[(i*6)+1] = iTime(pair,tf[i],0);
      touch.alert.toggle[i] = false;
      v = ObjectGet(TAG+tf[i],OBJPROP_PRICE1);
      if((Bid == v) || (last.bid[i]>v && Bid<v) || (last.bid[i]<v && Bid>v)){
         touch.alert=true;
         touch.alert.toggle[i] = true;
      }
      last.bid[i] = Bid;
   }
   if(touch.alert) Alert("Line Touched!");
}

void crossAlert(){
   cross.alert=false;
   for(i=0;i<9;i++){
      if(barstart[i*6] == iTime(pair,tf[i],0)) continue;
      barstart[i*6] = iTime(pair,tf[i],0);
      v = ObjectGet(TAG+tf[i],OBJPROP_PRICE1);
      if((iClose(pair,tf[i],1) > v && iClose(pair,tf[i],2) <= v) || (iClose(pair,tf[i],1) < v && iClose(pair,tf[i],2) >= v)) cross.alert=true;
   }
   if(cross.alert) Alert("Line in the Sand has been closed across!");
}

void lineValue(){
   for(i=0;i<9;i++){
      v = ObjectGet(TAG+tf[i],OBJPROP_PRICE1);
      if(DoubleToStr(v,Digits) != hud.data[(i*6)+6]){
         hud.data[(i*6)] = DoubleToStr(ObjectGet(TAG+tf[i],OBJPROP_PRICE1),Digits);
         for(j=0;j<6;j++) barstart[(j*i)+j]=0; //if line moves the rest of these values will be recalculated.
         dh[0]=true;
}  }  }

void currentPrice(){
   dh[1] = true;
   for(i=0;i<9;i++){
      v = ObjectGet(TAG+tf[i],OBJPROP_PRICE1);
      if(Bid > v) {
         hud.data[(i*6)+1] = arrow.up;
         hud.dc[(i*6)+1] = color.up;
      } else if(Bid < v) {
         hud.data[(i*6)+1] = arrow.dn;
         hud.dc[(i*6)+1] = color.dn;
      } else { 
         hud.data[(i*6)+1] = arrow.eq;
         hud.dc[(i*6)+1] = color.eq;
}  }  }

void lastClose(){
   for(i=0;i<9;i++){// if(newBar(i)){
      if(barstart[(i*6)+2] == iTime(pair,tf[i],0)) continue;
      barstart[(i*6)+2] = iTime(pair,tf[i],0);
      v = ObjectGet(TAG+tf[i],OBJPROP_PRICE1);
      dh[2] = true;
      if(iClose(pair,tf[i],1) > v) {
         hud.data[(i*6)+2] = arrow.up;
         hud.dc[(i*6)+2] = color.up;
      } else if(iClose(pair,tf[i],1) < v) {
         hud.data[(i*6)+2] = arrow.dn;
         hud.dc[(i*6)+2] = color.dn;
      } else { 
         hud.data[(i*6)+2] = arrow.eq;
         hud.dc[(i*6)+2] = color.eq;
}  }  }

void lastCross(){
   for(i=0;i<9;i++){
      if(barstart[(i*6)+3] == iTime(pair,tf[i],0)) continue;
      barstart[(i*6)+3] = iTime(pair,tf[i],0);
      dh[3] = true;
      dh[4] = true;
      wcd=0;
      wcu=0;
      v = ObjectGet(TAG+tf[i],OBJPROP_PRICE1);
      for(j=1;j<iBars(pair,tf[i]);j++) if(iClose(pair,tf[i],j)>v && iClose(pair,tf[i],j+1)<=v) {lcu = j; break;}
      for(j=1;j<iBars(pair,tf[i]);j++) if(iClose(pair,tf[i],j)<v && iClose(pair,tf[i],j+1)>=v) {lcd = j; break;}
      if(lcu==1 || lcd==1) close.alert=true;
      if(lcd>lcu){
         for(j=0;j<lcu-1;j++) if(iLow(pair,tf[i],j)<=v) wcu++;
         hud.data[(i*6)+3] = arrow.up;
         hud.dc[(i*6)+3] = color.up;
         hud.data[(i*6)+4] = wcu;
      } else {
         for(j=0;j<lcd-1;j++) if(iHigh(pair,tf[i],j)>=v) wcd++;
         hud.data[(i*6)+3] = arrow.dn;
         hud.dc[(i*6)+3] = color.dn;      
         hud.data[(i*6)+4] = wcd;
}  }  }

void distance(){
   for(i=0;i<9;i++){// if(newBar(i)){
      v = Bid - ObjectGet(TAG+tf[i],OBJPROP_PRICE1);
      dh[5] = true;
      if(v>0) {
         hud.data[(i*6)+5] = DoubleToStr(v/point,1);
         hud.dc[(i*6)+5] = color.up;
      } else if(v<0) {
         hud.data[(i*6)+5] = DoubleToStr(MathAbs(v/point),1);
         hud.dc[(i*6)+5] = color.dn;
      } else { 
         hud.data[(i*6)+5] = DoubleToStr(v/point,1);
         hud.dc[(i*6)+5] = color.eq;
}  }  }

void setLine(){
   st[0] = style.m1;
   wd[0] = width.m1;
   c[0] = color.m1;
   st[1] = style.m5;
   wd[1] = width.m5;
   c[1] = color.m5;
   st[2] = style.m15;
   wd[2] = width.m15;
   c[2] = color.m15;
   st[3] = style.m30;
   wd[3] = width.m30;
   c[3] = color.m30;
   st[4] = style.h1;
   wd[4] = width.h1;
   c[4] = color.h1;
   st[5] = style.h4;
   wd[5] = width.h4;
   c[5] = color.h4;
   st[6] = style.d1;
   wd[6] = width.d1;
   c[6] = color.d1;
   st[7] = style.w1;
   wd[7] = width.w1;
   c[7] = color.w1;
   st[8] = style.mn;
   wd[8] = width.mn;
   c[8] = color.mn;
   for(i=0;i<9;i++) drawLine(TAG+tf[i],c[i],st[i],wd[i],background.lines,Bid,showtf[i]);
   if(show.all.lines) for(i=0;i<9;i++) ObjectSet(TAG+tf[i], OBJPROP_TIMEFRAMES, 0);
      else for(i=0;i<9;i++) ObjectSet(TAG+tf[i], OBJPROP_TIMEFRAMES, showtf[i]);
}

void drawLine(string n, color c, int s, int w, bool b, double p, int t){
   if(ObjectFind(n)==0) return;
   ObjectCreate(n, OBJ_HLINE, 0,0,0);
   ObjectSet(n, OBJPROP_COLOR, c);
   ObjectSet(n, OBJPROP_STYLE, s);
   ObjectSet(n, OBJPROP_WIDTH, w);
   ObjectSet(n, OBJPROP_BACK, b);
   ObjectSet(n, OBJPROP_PRICE1, p);
   ObjectSet(n, OBJPROP_TIMEFRAMES, t);
}

void DrawText(string h, string l, string t, int x, int y, color c, string f, int s, int k=0, int a=0, bool b=false){
   string tag = h+TAG+l+x+y;
   ObjectDelete(tag);
   ObjectCreate(tag,OBJ_LABEL,0,0,0);
   ObjectSetText(tag,t,s,f,c);
   ObjectSet(tag,OBJPROP_XDISTANCE,x);
   ObjectSet(tag,OBJPROP_YDISTANCE,y);
   ObjectSet(tag,OBJPROP_CORNER,k);
   ObjectSet(tag,OBJPROP_ANGLE,a);
   if(b) ObjectSet(tag,OBJPROP_BACK,true);
}

void help(){
   string s;
   s = s + "HELP for II LiS can be found at\nhttp://insanityinductries.net/";
   Comment(s);
}

void ObDeleteObjectsByPrefix(string Prefix){ //code by TRO
   int L = StringLen(Prefix);
   int i = 0; 
   while(i < ObjectsTotal()) {
      string ObjName = ObjectName(i);
      if(StringSubstr(ObjName, 0, L) != Prefix) {
         i++;
         continue;
      }
      ObjectDelete(ObjName);
}  }

void DrawCell(int nWindow, string nCellName, double nX, double nY, double nWidth, double nHeight, color nColor, int cnr){ //Base Code from MT4 codebase
   double iHeight, iWidth, iXSpace;
   int iSquares, i;
   if(nWidth > nHeight){
     iSquares = MathCeil(nWidth/nHeight);      // Number of squares used.
     iHeight = MathRound((nHeight*100)/77);   // Real height size.
     iWidth = MathRound((nWidth*100)/77);    // Real width size.
     iXSpace = iWidth/iSquares - ((iHeight/(9-(nHeight/100)))*2);
     ObDeleteObjectsByPrefix(nCellName);
      for(i=0;i<iSquares;i++){
         ObjectCreate(nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText(nCellName+i, CharToStr(110),iHeight, "Wingdings", nColor);
         ObjectSet(nCellName+i, OBJPROP_XDISTANCE,nX + iXSpace*i);
         ObjectSet(nCellName+i, OBJPROP_YDISTANCE,nY);    
         ObjectSet(nCellName+i, OBJPROP_BACK, false);
         ObjectSet(nCellName+i, OBJPROP_CORNER, cnr);
      }        
   }else{
      iSquares = MathCeil(nHeight/nWidth);      // Number of squares used.
      iHeight  = MathRound((nHeight*100)/77);   // Real height size.
      iWidth   = MathRound((nWidth*100)/77);    // Real width size.
      iXSpace  = iHeight/iSquares - ((iWidth/(9-(nWidth/100)))*2);
      for(i=0;i<iSquares;i++){
         ObjectCreate   (nCellName+i, OBJ_LABEL,nWindow,0,0);
         ObjectSetText  (nCellName+i, CharToStr(110),iWidth, "Wingdings", nColor);
         ObjectSet      (nCellName+i, OBJPROP_XDISTANCE,nX);
         ObjectSet      (nCellName+i, OBJPROP_YDISTANCE,nY + iXSpace*i);    
         ObjectSet      (nCellName+i, OBJPROP_BACK, false);
         ObjectSet      (nCellName+i, OBJPROP_CORNER, cnr);
}  }  }

void DoLogo(){
   string TAG = CharToStr(0x61+27)+"II_Logo";
   if( ObjectFind(TAG+"ZZ"+0) >= 0 && ObjectFind(TAG+"ZZ"+1) >= 0 && ObjectFind(TAG+"ZZ"+2) >= 0  && 
       ObjectFind(TAG+"AZ"+0) >= 0 && ObjectFind(TAG+"AZ"+1) >= 0 && ObjectFind(TAG+"AZ"+2) >= 0 ) return;
   string str[3] = {"$","Insanity","Industries"};
   int size[3] = {25,10,10};
   int pos.x[3] = {47,19,17};
   int pos.y[3] = {10,25,15};
   int pos.xs[3] = {46,18,16};
   int pos.ys[3] = {9,24,14};
   for(int i=0;i<3;i++){
      string n = TAG+"ZZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",AliceBlue);
      ObjectSet(n,OBJPROP_XDISTANCE,pos.x[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos.y[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
      n = TAG+"AZ"+i;
      ObjectDelete(n);
      ObjectCreate(n,OBJ_LABEL,0,0,0);
      ObjectSetText(n,str[i],size[i],"Pieces Of Eight",Black);
      ObjectSet(n,OBJPROP_XDISTANCE,pos.xs[i]);
      ObjectSet(n,OBJPROP_YDISTANCE,pos.ys[i]);
      ObjectSet(n,OBJPROP_CORNER,3);
}  }

void setBox(){
   boxHUD(x.hud,y.hud,hud.corner,color.box,color.border,l.c+TAG+"bc", 76, 23, 5);
}

void boxHUD(int x, int y, int c, color bx, color bd, string l, int w, int m, int n){
   for(i=0;i<m;i++) for(j=0;j<n;j++) DrawCell(0,l+CharToStr(0x1+i)+"bg"+CharToStr(0x1+j), x+(j*42), y+(i*12), w, 12, bd, c);
   y++;
   for(j=0;j<n;j++) DrawCell(0,l+CharToStr(0x1+i)+"fg"+CharToStr(0x1+j) , x+box.xoffset[j], y+((m-1)*12)-2, w, 12, bx, c);
   for(i=0;i<(m-1);i++){
      if(i==1) y--;
      for(j=0;j<n;j++) DrawCell(0,l+CharToStr(0x1+i)+"fg"+CharToStr(0x1+j) , x+box.xoffset[j], y+(i*12), w, 12, bx, c);
}  }

void headerHUD(){
   for(i=0;i<18;i++){
      DrawText(l.hud,1,hud.header[i],hud.x[hud.t[i]] ,hud.y[hud.t[i]] ,hud.t.c[i] ,hud.fhn[i],hud.fhs[i],hud.corner,hud.ha[i],false);
      DrawText(l.hud,0,hud.header[i],hud.xs[hud.t[i]],hud.ys[hud.t[i]],hud.t.cs[i],hud.fhn[i],hud.fhs[i],hud.corner,hud.ha[i],false);     
}  }


void setHeaders(){
   headerHUD();
}

void drawData(){
   for(j=0;j<9;j++){
      for(i=0;i<6;i++)
         if(dh[i]) DrawText(l.hud,0,hud.data[(j*6)+i],hud.x[hud.d[(j*6)+i]],hud.y[hud.d[(j*6)+i]],hud.dc[(j*6)+i],hud.dfn[(j*6)+i],hud.dfs[(j*6)+i],hud.corner,0,false);
   }
   ArrayInitialize(dh,false);
}

void setHUD(){
   int r = 7;
   int c = 10;
   hud.corner = 0;
   if(hud.corner > 3) hud.corner=0;
   switch(hud.corner){
      case 0 : offset.x = 1;
               offset.y = 1;
               x.hud = pos.x;
               y.hud = pos.y;
               hud.x[0] = x.hud+hud.offset.l[0];
               hud.y[0] = y.hud+5;
               for(j=0;j<c;j++) for(i=0;i<r;i++) hud.x[(j*r)+i+1] = x.hud + hud.col.l[i] + hud.offset.l[(j*c)+i+1];
               for(j=0;j<c;j++) for(i=0;i<r;i++) hud.y[(j*r)+i+1] = y.hud + hud.row.u[j];
               for(i=0;i<r;i++) hud.y[i+1] += hud.offset.hy.l[i]; // header shift y
               hud.x[71] = x.hud+7;//hud.offset.r[17];
               hud.y[71] = y.hud+2;
               break;
      case 1 : offset.x = 1;
               offset.y = 1;
               x.hud = pos.x;
               y.hud = pos.y;
               hud.x[0] = x.hud+hud.offset.r[0];
               hud.y[0] = y.hud+5;
               for(j=0;j<c;j++) for(i=0;i<r;i++) hud.x[(j*r)+i+1] = x.hud + hud.col.r[i] + hud.offset.r[(j*c)+i+1];
               for(j=0;j<c;j++) for(i=0;i<r;i++) hud.y[(j*r)+i+1] = y.hud + hud.row.u[j];
               for(i=0;i<r;i++) hud.y[i+1] += hud.offset.hy.r[i]; // header shift y
               hud.x[71] = x.hud+133;//hud.offset.r[17];
               hud.y[71] = y.hud+2;
               break;
      case 2 : offset.x = 1;
               offset.y = -1;
               break;
      case 3 : offset.x = -1;
               offset.y = -1;
               break;
   }

   for(i=0;i<81;i++){
      hud.xs[i] = hud.x[i]+offset.x;
      hud.ys[i] = hud.y[i]+offset.y;
   }
   if(show.Box) setBox();
   setHeaders();
}

